-----------------------------------------------------------------------
--  AWA.Events.Models -- AWA.Events.Models
-----------------------------------------------------------------------
--  File generated by Dynamo DO NOT MODIFY
--  Template used: templates/model/package-body.xhtml
--  Ada Generator: https://github.com/stcarrez/dynamo Version 1.2.3
-----------------------------------------------------------------------
--  Copyright (C) 2022 Stephane Carrez
--  Written by Stephane Carrez (Stephane.Carrez@gmail.com)
--
--  Licensed under the Apache License, Version 2.0 (the "License");
--  you may not use this file except in compliance with the License.
--  You may obtain a copy of the License at
--
--      http://www.apache.org/licenses/LICENSE-2.0
--
--  Unless required by applicable law or agreed to in writing, software
--  distributed under the License is distributed on an "AS IS" BASIS,
--  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--  See the License for the specific language governing permissions and
--  limitations under the License.
-----------------------------------------------------------------------
pragma Warnings (Off);
with Ada.Unchecked_Deallocation;
with Util.Beans.Objects.Time;
pragma Warnings (On);
package body AWA.Events.Models is

   pragma Style_Checks ("-mrIu");
   pragma Warnings (Off, "formal parameter * is not referenced");
   pragma Warnings (Off, "use clause for type *");
   pragma Warnings (Off, "use clause for private type *");

   use type ADO.Objects.Object_Record_Access;
   use type ADO.Objects.Object_Ref;

   function Message_Type_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => MESSAGE_TYPE_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Message_Type_Key;

   function Message_Type_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => MESSAGE_TYPE_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Message_Type_Key;

   function "=" (Left, Right : Message_Type_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Message_Type_Ref'Class;
                        Impl   : out Message_Type_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Message_Type_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   overriding
   procedure Allocate (Object : in out Message_Type_Ref) is
      Impl : Message_Type_Access;
   begin
      Impl := new Message_Type_Impl;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Message_Type
   -- ----------------------------------------

   procedure Set_Id (Object : in out Message_Type_Ref;
                     Value  : in ADO.Identifier) is
      Impl : Message_Type_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Message_Type_Ref)
                  return ADO.Identifier is
      Impl : constant Message_Type_Access
         := Message_Type_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Name (Object : in out Message_Type_Ref;
                        Value : in String) is
      Impl : Message_Type_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 2, Impl.Name, Value);
   end Set_Name;

   procedure Set_Name (Object : in out Message_Type_Ref;
                       Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Message_Type_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Unbounded_String (Impl.all, 2, Impl.Name, Value);
   end Set_Name;

   function Get_Name (Object : in Message_Type_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Name);
   end Get_Name;
   function Get_Name (Object : in Message_Type_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Message_Type_Access
         := Message_Type_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Name;
   end Get_Name;

   --  Copy of the object.
   procedure Copy (Object : in Message_Type_Ref;
                   Into   : in out Message_Type_Ref) is
      Result : Message_Type_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Message_Type_Access
              := Message_Type_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Message_Type_Access
              := new Message_Type_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.Name := Impl.Name;
         end;
      end if;
      Into := Result;
   end Copy;

   overriding
   procedure Find (Object  : in out Message_Type_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Message_Type_Access := new Message_Type_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Message_Type_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier) is
      Impl  : constant Message_Type_Access := new Message_Type_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Message_Type_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier;
                   Found   : out Boolean) is
      Impl  : constant Message_Type_Access := new Message_Type_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Message_Type_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Message_Type_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   overriding
   procedure Delete (Object  : in out Message_Type_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   overriding
   procedure Destroy (Object : access Message_Type_Impl) is
      type Message_Type_Impl_Ptr is access all Message_Type_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Message_Type_Impl, Message_Type_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Message_Type_Impl_Ptr := Message_Type_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   overriding
   procedure Find (Object  : in out Message_Type_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, MESSAGE_TYPE_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Message_Type_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant ADO.Identifier := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Message_Type_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (MESSAGE_TYPE_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_1_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_1_NAME, --  name
                          Value => Object.Name);
         Object.Clear_Modified (2);
      end if;
      if Stmt.Has_Save_Fields then
         Stmt.Set_Filter (Filter => "id = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               end if;
            end if;
         end;
      end if;
   end Save;

   overriding
   procedure Create (Object  : in out Message_Type_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (MESSAGE_TYPE_DEF'Access);
      Result : Integer;
   begin
      Session.Allocate (Id => Object);
      Query.Save_Field (Name  => COL_0_1_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_1_NAME, --  name
                        Value => Object.Name);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
   end Create;

   overriding
   procedure Delete (Object  : in out Message_Type_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (MESSAGE_TYPE_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Message_Type_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Message_Type_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Message_Type_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "name" then
         return Util.Beans.Objects.To_Object (Impl.Name);
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   procedure List (Object  : in out Message_Type_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class) is
      Stmt : ADO.Statements.Query_Statement
        := Session.Create_Statement (Query, MESSAGE_TYPE_DEF'Access);
   begin
      Stmt.Execute;
      Message_Type_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         declare
            Item : Message_Type_Ref;
            Impl : constant Message_Type_Access := new Message_Type_Impl;
         begin
            Impl.Load (Stmt, Session);
            ADO.Objects.Set_Object (Item, Impl.all'Access);
            Object.Append (Item);
         end;
         Stmt.Next;
      end loop;
   end List;

   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Message_Type_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
      pragma Unreferenced (Session);
   begin
      Object.Set_Key_Value (Stmt.Get_Identifier (0));
      Object.Name := Stmt.Get_Unbounded_String (1);
      ADO.Objects.Set_Created (Object);
   end Load;
   function Queue_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => QUEUE_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Queue_Key;

   function Queue_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => QUEUE_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Queue_Key;

   function "=" (Left, Right : Queue_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Queue_Ref'Class;
                        Impl   : out Queue_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Queue_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   overriding
   procedure Allocate (Object : in out Queue_Ref) is
      Impl : Queue_Access;
   begin
      Impl := new Queue_Impl;
      Impl.Server_Id := 0;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Queue
   -- ----------------------------------------

   procedure Set_Id (Object : in out Queue_Ref;
                     Value  : in ADO.Identifier) is
      Impl : Queue_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Queue_Ref)
                  return ADO.Identifier is
      Impl : constant Queue_Access
         := Queue_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Server_Id (Object : in out Queue_Ref;
                            Value  : in Integer) is
      Impl : Queue_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Integer (Impl.all, 2, Impl.Server_Id, Value);
   end Set_Server_Id;

   function Get_Server_Id (Object : in Queue_Ref)
                  return Integer is
      Impl : constant Queue_Access
         := Queue_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Server_Id;
   end Get_Server_Id;


   procedure Set_Name (Object : in out Queue_Ref;
                        Value : in String) is
      Impl : Queue_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 3, Impl.Name, Value);
   end Set_Name;

   procedure Set_Name (Object : in out Queue_Ref;
                       Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Queue_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Unbounded_String (Impl.all, 3, Impl.Name, Value);
   end Set_Name;

   function Get_Name (Object : in Queue_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Name);
   end Get_Name;
   function Get_Name (Object : in Queue_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Queue_Access
         := Queue_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Name;
   end Get_Name;

   --  Copy of the object.
   procedure Copy (Object : in Queue_Ref;
                   Into   : in out Queue_Ref) is
      Result : Queue_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Queue_Access
              := Queue_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Queue_Access
              := new Queue_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.Server_Id := Impl.Server_Id;
            Copy.Name := Impl.Name;
         end;
      end if;
      Into := Result;
   end Copy;

   overriding
   procedure Find (Object  : in out Queue_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Queue_Access := new Queue_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Queue_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier) is
      Impl  : constant Queue_Access := new Queue_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Queue_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier;
                   Found   : out Boolean) is
      Impl  : constant Queue_Access := new Queue_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Queue_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Queue_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   overriding
   procedure Delete (Object  : in out Queue_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   overriding
   procedure Destroy (Object : access Queue_Impl) is
      type Queue_Impl_Ptr is access all Queue_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Queue_Impl, Queue_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Queue_Impl_Ptr := Queue_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   overriding
   procedure Find (Object  : in out Queue_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, QUEUE_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Queue_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant ADO.Identifier := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Queue_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (QUEUE_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_2_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_2_NAME, --  server_id
                          Value => Object.Server_Id);
         Object.Clear_Modified (2);
      end if;
      if Object.Is_Modified (3) then
         Stmt.Save_Field (Name  => COL_2_2_NAME, --  name
                          Value => Object.Name);
         Object.Clear_Modified (3);
      end if;
      if Stmt.Has_Save_Fields then
         Stmt.Set_Filter (Filter => "id = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               end if;
            end if;
         end;
      end if;
   end Save;

   overriding
   procedure Create (Object  : in out Queue_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (QUEUE_DEF'Access);
      Result : Integer;
   begin
      Session.Allocate (Id => Object);
      Query.Save_Field (Name  => COL_0_2_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_2_NAME, --  server_id
                        Value => Object.Server_Id);
      Query.Save_Field (Name  => COL_2_2_NAME, --  name
                        Value => Object.Name);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
   end Create;

   overriding
   procedure Delete (Object  : in out Queue_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (QUEUE_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Queue_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Queue_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Queue_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "server_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Server_Id));
      elsif Name = "name" then
         return Util.Beans.Objects.To_Object (Impl.Name);
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;



   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Queue_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
      pragma Unreferenced (Session);
   begin
      Object.Set_Key_Value (Stmt.Get_Identifier (0));
      Object.Server_Id := Stmt.Get_Integer (1);
      Object.Name := Stmt.Get_Unbounded_String (2);
      ADO.Objects.Set_Created (Object);
   end Load;
   function Message_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => MESSAGE_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Message_Key;

   function Message_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => MESSAGE_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Message_Key;

   function "=" (Left, Right : Message_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Message_Ref'Class;
                        Impl   : out Message_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Message_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   overriding
   procedure Allocate (Object : in out Message_Ref) is
      Impl : Message_Access;
   begin
      Impl := new Message_Impl;
      Impl.Create_Date := ADO.DEFAULT_TIME;
      Impl.Priority := 0;
      Impl.Count := 0;
      Impl.Server_Id := 0;
      Impl.Task_Id := 0;
      Impl.Status := Message_Status_Type'First;
      Impl.Processing_Date.Is_Null := True;
      Impl.Version := 0;
      Impl.Entity_Id := ADO.NO_IDENTIFIER;
      Impl.Entity_Type := 0;
      Impl.Finish_Date.Is_Null := True;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Message
   -- ----------------------------------------

   procedure Set_Id (Object : in out Message_Ref;
                     Value  : in ADO.Identifier) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Message_Ref)
                  return ADO.Identifier is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Create_Date (Object : in out Message_Ref;
                              Value  : in Ada.Calendar.Time) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Time (Impl.all, 2, Impl.Create_Date, Value);
   end Set_Create_Date;

   function Get_Create_Date (Object : in Message_Ref)
                  return Ada.Calendar.Time is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Create_Date;
   end Get_Create_Date;


   procedure Set_Priority (Object : in out Message_Ref;
                           Value  : in Integer) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Integer (Impl.all, 3, Impl.Priority, Value);
   end Set_Priority;

   function Get_Priority (Object : in Message_Ref)
                  return Integer is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Priority;
   end Get_Priority;


   procedure Set_Count (Object : in out Message_Ref;
                        Value  : in Integer) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Integer (Impl.all, 4, Impl.Count, Value);
   end Set_Count;

   function Get_Count (Object : in Message_Ref)
                  return Integer is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Count;
   end Get_Count;


   procedure Set_Parameters (Object : in out Message_Ref;
                              Value : in String) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 5, Impl.Parameters, Value);
   end Set_Parameters;

   procedure Set_Parameters (Object : in out Message_Ref;
                             Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Unbounded_String (Impl.all, 5, Impl.Parameters, Value);
   end Set_Parameters;

   function Get_Parameters (Object : in Message_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Parameters);
   end Get_Parameters;
   function Get_Parameters (Object : in Message_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Parameters;
   end Get_Parameters;


   procedure Set_Server_Id (Object : in out Message_Ref;
                            Value  : in Integer) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Integer (Impl.all, 6, Impl.Server_Id, Value);
   end Set_Server_Id;

   function Get_Server_Id (Object : in Message_Ref)
                  return Integer is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Server_Id;
   end Get_Server_Id;


   procedure Set_Task_Id (Object : in out Message_Ref;
                          Value  : in Integer) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Integer (Impl.all, 7, Impl.Task_Id, Value);
   end Set_Task_Id;

   function Get_Task_Id (Object : in Message_Ref)
                  return Integer is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Task_Id;
   end Get_Task_Id;


   procedure Set_Status (Object : in out Message_Ref;
                         Value  : in Message_Status_Type) is
      procedure Set_Field_Discrete is
        new ADO.Objects.Set_Field_Operation
          (Message_Status_Type);
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      Set_Field_Discrete (Impl.all, 8, Impl.Status, Value);
   end Set_Status;

   function Get_Status (Object : in Message_Ref)
                  return Message_Status_Type is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Status;
   end Get_Status;


   procedure Set_Processing_Date (Object : in out Message_Ref;
                                  Value  : in ADO.Nullable_Time) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Time (Impl.all, 9, Impl.Processing_Date, Value);
   end Set_Processing_Date;

   function Get_Processing_Date (Object : in Message_Ref)
                  return ADO.Nullable_Time is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Processing_Date;
   end Get_Processing_Date;


   function Get_Version (Object : in Message_Ref)
                  return Integer is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Version;
   end Get_Version;


   procedure Set_Entity_Id (Object : in out Message_Ref;
                            Value  : in ADO.Identifier) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Identifier (Impl.all, 11, Impl.Entity_Id, Value);
   end Set_Entity_Id;

   function Get_Entity_Id (Object : in Message_Ref)
                  return ADO.Identifier is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Entity_Id;
   end Get_Entity_Id;


   procedure Set_Entity_Type (Object : in out Message_Ref;
                              Value  : in ADO.Entity_Type) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Entity_Type (Impl.all, 12, Impl.Entity_Type, Value);
   end Set_Entity_Type;

   function Get_Entity_Type (Object : in Message_Ref)
                  return ADO.Entity_Type is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Entity_Type;
   end Get_Entity_Type;


   procedure Set_Finish_Date (Object : in out Message_Ref;
                              Value  : in ADO.Nullable_Time) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Time (Impl.all, 13, Impl.Finish_Date, Value);
   end Set_Finish_Date;

   function Get_Finish_Date (Object : in Message_Ref)
                  return ADO.Nullable_Time is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Finish_Date;
   end Get_Finish_Date;


   procedure Set_Queue (Object : in out Message_Ref;
                        Value  : in Queue_Ref'Class) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 14, Impl.Queue, Value);
   end Set_Queue;

   function Get_Queue (Object : in Message_Ref)
                  return Queue_Ref'Class is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Queue;
   end Get_Queue;


   procedure Set_Message_Type (Object : in out Message_Ref;
                               Value  : in Message_Type_Ref'Class) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 15, Impl.Message_Type, Value);
   end Set_Message_Type;

   function Get_Message_Type (Object : in Message_Ref)
                  return Message_Type_Ref'Class is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Message_Type;
   end Get_Message_Type;


   procedure Set_User (Object : in out Message_Ref;
                       Value  : in AWA.Users.Models.User_Ref'Class) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 16, Impl.User, Value);
   end Set_User;

   function Get_User (Object : in Message_Ref)
                  return AWA.Users.Models.User_Ref'Class is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.User;
   end Get_User;


   procedure Set_Session (Object : in out Message_Ref;
                          Value  : in AWA.Users.Models.Session_Ref'Class) is
      Impl : Message_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Object (Impl.all, 17, Impl.Session, Value);
   end Set_Session;

   function Get_Session (Object : in Message_Ref)
                  return AWA.Users.Models.Session_Ref'Class is
      Impl : constant Message_Access
         := Message_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Session;
   end Get_Session;

   --  Copy of the object.
   procedure Copy (Object : in Message_Ref;
                   Into   : in out Message_Ref) is
      Result : Message_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Message_Access
              := Message_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Message_Access
              := new Message_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.Create_Date := Impl.Create_Date;
            Copy.Priority := Impl.Priority;
            Copy.Count := Impl.Count;
            Copy.Parameters := Impl.Parameters;
            Copy.Server_Id := Impl.Server_Id;
            Copy.Task_Id := Impl.Task_Id;
            Copy.Status := Impl.Status;
            Copy.Processing_Date := Impl.Processing_Date;
            Copy.Version := Impl.Version;
            Copy.Entity_Id := Impl.Entity_Id;
            Copy.Entity_Type := Impl.Entity_Type;
            Copy.Finish_Date := Impl.Finish_Date;
            Copy.Queue := Impl.Queue;
            Copy.Message_Type := Impl.Message_Type;
            Copy.User := Impl.User;
            Copy.Session := Impl.Session;
         end;
      end if;
      Into := Result;
   end Copy;

   overriding
   procedure Find (Object  : in out Message_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Message_Access := new Message_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Message_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier) is
      Impl  : constant Message_Access := new Message_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Message_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier;
                   Found   : out Boolean) is
      Impl  : constant Message_Access := new Message_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   procedure Reload (Object  : in out Message_Ref;
                     Session : in out ADO.Sessions.Session'Class;
                     Updated : out Boolean) is
      Result : ADO.Objects.Object_Record_Access;
      Impl   : Message_Access;
      Query  : ADO.SQL.Query;
      Id     : ADO.Identifier;
   begin
      if Object.Is_Null then
         raise ADO.Objects.NULL_ERROR;
      end if;
      Object.Prepare_Modify (Result);
      Impl := Message_Impl (Result.all)'Access;
      Id := ADO.Objects.Get_Key_Value (Impl.all);
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Bind_Param (Position => 2, Value => Impl.Version);
      Query.Set_Filter ("id = ? AND version != ?");
      declare
         Stmt : ADO.Statements.Query_Statement
             := Session.Create_Statement (Query, MESSAGE_DEF'Access);
      begin
         Stmt.Execute;
         if Stmt.Has_Elements then
            Updated := True;
            Impl.Load (Stmt, Session);
         else
            Updated := False;
         end if;
      end;
   end Reload;

   overriding
   procedure Save (Object  : in out Message_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Message_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   overriding
   procedure Delete (Object  : in out Message_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   overriding
   procedure Destroy (Object : access Message_Impl) is
      type Message_Impl_Ptr is access all Message_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Message_Impl, Message_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Message_Impl_Ptr := Message_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   overriding
   procedure Find (Object  : in out Message_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, MESSAGE_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Message_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant ADO.Identifier := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Message_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (MESSAGE_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_3_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_3_NAME, --  create_date
                          Value => Object.Create_Date);
         Object.Clear_Modified (2);
      end if;
      if Object.Is_Modified (3) then
         Stmt.Save_Field (Name  => COL_2_3_NAME, --  priority
                          Value => Object.Priority);
         Object.Clear_Modified (3);
      end if;
      if Object.Is_Modified (4) then
         Stmt.Save_Field (Name  => COL_3_3_NAME, --  count
                          Value => Object.Count);
         Object.Clear_Modified (4);
      end if;
      if Object.Is_Modified (5) then
         Stmt.Save_Field (Name  => COL_4_3_NAME, --  parameters
                          Value => Object.Parameters);
         Object.Clear_Modified (5);
      end if;
      if Object.Is_Modified (6) then
         Stmt.Save_Field (Name  => COL_5_3_NAME, --  server_id
                          Value => Object.Server_Id);
         Object.Clear_Modified (6);
      end if;
      if Object.Is_Modified (7) then
         Stmt.Save_Field (Name  => COL_6_3_NAME, --  task_id
                          Value => Object.Task_Id);
         Object.Clear_Modified (7);
      end if;
      if Object.Is_Modified (8) then
         Stmt.Save_Field (Name  => COL_7_3_NAME, --  status
                          Value => Integer (Message_Status_Type'Enum_Rep (Object.Status)));
         Object.Clear_Modified (8);
      end if;
      if Object.Is_Modified (9) then
         Stmt.Save_Field (Name  => COL_8_3_NAME, --  processing_date
                          Value => Object.Processing_Date);
         Object.Clear_Modified (9);
      end if;
      if Object.Is_Modified (11) then
         Stmt.Save_Field (Name  => COL_10_3_NAME, --  entity_id
                          Value => Object.Entity_Id);
         Object.Clear_Modified (11);
      end if;
      if Object.Is_Modified (12) then
         Stmt.Save_Field (Name  => COL_11_3_NAME, --  entity_type
                          Value => Object.Entity_Type);
         Object.Clear_Modified (12);
      end if;
      if Object.Is_Modified (13) then
         Stmt.Save_Field (Name  => COL_12_3_NAME, --  finish_date
                          Value => Object.Finish_Date);
         Object.Clear_Modified (13);
      end if;
      if Object.Is_Modified (14) then
         Stmt.Save_Field (Name  => COL_13_3_NAME, --  queue_id
                          Value => Object.Queue);
         Object.Clear_Modified (14);
      end if;
      if Object.Is_Modified (15) then
         Stmt.Save_Field (Name  => COL_14_3_NAME, --  message_type_id
                          Value => Object.Message_Type);
         Object.Clear_Modified (15);
      end if;
      if Object.Is_Modified (16) then
         Stmt.Save_Field (Name  => COL_15_3_NAME, --  user_id
                          Value => Object.User);
         Object.Clear_Modified (16);
      end if;
      if Object.Is_Modified (17) then
         Stmt.Save_Field (Name  => COL_16_3_NAME, --  session_id
                          Value => Object.Session);
         Object.Clear_Modified (17);
      end if;
      if Stmt.Has_Save_Fields then
         Object.Version := Object.Version + 1;
         Stmt.Save_Field (Name  => "version",
                          Value => Object.Version);
         Stmt.Set_Filter (Filter => "id = ? and version = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         Stmt.Add_Param (Value => Object.Version - 1);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               else
                  raise ADO.Objects.LAZY_LOCK;
               end if;
            end if;
         end;
      end if;
   end Save;

   overriding
   procedure Create (Object  : in out Message_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (MESSAGE_DEF'Access);
      Result : Integer;
   begin
      Object.Version := 1;
      Session.Allocate (Id => Object);
      Query.Save_Field (Name  => COL_0_3_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_3_NAME, --  create_date
                        Value => Object.Create_Date);
      Query.Save_Field (Name  => COL_2_3_NAME, --  priority
                        Value => Object.Priority);
      Query.Save_Field (Name  => COL_3_3_NAME, --  count
                        Value => Object.Count);
      Query.Save_Field (Name  => COL_4_3_NAME, --  parameters
                        Value => Object.Parameters);
      Query.Save_Field (Name  => COL_5_3_NAME, --  server_id
                        Value => Object.Server_Id);
      Query.Save_Field (Name  => COL_6_3_NAME, --  task_id
                        Value => Object.Task_Id);
      Query.Save_Field (Name  => COL_7_3_NAME, --  status
                        Value => Integer (Message_Status_Type'Enum_Rep (Object.Status)));
      Query.Save_Field (Name  => COL_8_3_NAME, --  processing_date
                        Value => Object.Processing_Date);
      Query.Save_Field (Name  => COL_9_3_NAME, --  version
                        Value => Object.Version);
      Query.Save_Field (Name  => COL_10_3_NAME, --  entity_id
                        Value => Object.Entity_Id);
      Query.Save_Field (Name  => COL_11_3_NAME, --  entity_type
                        Value => Object.Entity_Type);
      Query.Save_Field (Name  => COL_12_3_NAME, --  finish_date
                        Value => Object.Finish_Date);
      Query.Save_Field (Name  => COL_13_3_NAME, --  queue_id
                        Value => Object.Queue);
      Query.Save_Field (Name  => COL_14_3_NAME, --  message_type_id
                        Value => Object.Message_Type);
      Query.Save_Field (Name  => COL_15_3_NAME, --  user_id
                        Value => Object.User);
      Query.Save_Field (Name  => COL_16_3_NAME, --  session_id
                        Value => Object.Session);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
   end Create;

   overriding
   procedure Delete (Object  : in out Message_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (MESSAGE_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Message_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Message_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Message_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "create_date" then
         return Util.Beans.Objects.Time.To_Object (Impl.Create_Date);
      elsif Name = "priority" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Priority));
      elsif Name = "count" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Count));
      elsif Name = "parameters" then
         return Util.Beans.Objects.To_Object (Impl.Parameters);
      elsif Name = "server_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Server_Id));
      elsif Name = "task_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Task_Id));
      elsif Name = "status" then
         return Message_Status_Type_Objects.To_Object (Impl.Status);
      elsif Name = "processing_date" then
         if Impl.Processing_Date.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.Time.To_Object (Impl.Processing_Date.Value);
         end if;
      elsif Name = "entity_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Entity_Id));
      elsif Name = "entity_type" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Entity_Type));
      elsif Name = "finish_date" then
         if Impl.Finish_Date.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.Time.To_Object (Impl.Finish_Date.Value);
         end if;
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   procedure List (Object  : in out Message_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class) is
      Stmt : ADO.Statements.Query_Statement
        := Session.Create_Statement (Query, MESSAGE_DEF'Access);
   begin
      Stmt.Execute;
      Message_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         declare
            Item : Message_Ref;
            Impl : constant Message_Access := new Message_Impl;
         begin
            Impl.Load (Stmt, Session);
            ADO.Objects.Set_Object (Item, Impl.all'Access);
            Object.Append (Item);
         end;
         Stmt.Next;
      end loop;
   end List;

   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Message_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
   begin
      Object.Set_Key_Value (Stmt.Get_Identifier (0));
      Object.Create_Date := Stmt.Get_Time (1);
      Object.Priority := Stmt.Get_Integer (2);
      Object.Count := Stmt.Get_Integer (3);
      Object.Parameters := Stmt.Get_Unbounded_String (4);
      Object.Server_Id := Stmt.Get_Integer (5);
      Object.Task_Id := Stmt.Get_Integer (6);
      Object.Status := Message_Status_Type'Enum_Val (Stmt.Get_Integer (7));
      Object.Processing_Date := Stmt.Get_Nullable_Time (8);
      Object.Entity_Id := Stmt.Get_Identifier (10);
      Object.Entity_Type := ADO.Entity_Type (Stmt.Get_Integer (11));
      Object.Finish_Date := Stmt.Get_Nullable_Time (12);
      if not Stmt.Is_Null (13) then
         Object.Queue.Set_Key_Value (Stmt.Get_Identifier (13), Session);
      end if;
      if not Stmt.Is_Null (14) then
         Object.Message_Type.Set_Key_Value (Stmt.Get_Identifier (14), Session);
      end if;
      if not Stmt.Is_Null (15) then
         Object.User.Set_Key_Value (Stmt.Get_Identifier (15), Session);
      end if;
      if not Stmt.Is_Null (16) then
         Object.Session.Set_Key_Value (Stmt.Get_Identifier (16), Session);
      end if;
      Object.Version := Stmt.Get_Integer (9);
      ADO.Objects.Set_Created (Object);
   end Load;


end AWA.Events.Models;
